import { createStore } from 'redux';

/**
 * Initial state
 */
const initialState = {
  loading: false,
  previewLoading: false,
  previewItems: [],
  previewError: '',
}

/**
 * Update loading action
 */
export function updateLoading( value ) {
  return { type: 'UPDATE_LOADING', value: value }
}

/**
 * Update preview loading action
 */
export function previewLoading( value ) {
  return { type: 'PREVIEW_LOADING', value: value }
}

/**
 * Update preview items
 */
export function previewItems( value ) {
  return { type: 'PREVIEW_ITEMS', value: value }
}

/**
 * Update preview error message
 */
export function previewError( value ) {
  return { type: 'PREVIEW_ERROR', value: value }
}

/**
 * Reducer
 */
function rootReducer(state = initialState, action) {
  switch (action.type) {
    case 'UPDATE_LOADING':
      return Object.assign({}, state, {
        loading: action.value
      });

    case 'PREVIEW_LOADING':
      return Object.assign({}, state, {
        previewLoading: action.value
      });

    case 'PREVIEW_ITEMS':
      return Object.assign({}, state, {
        previewItems: action.value
      });

    case 'PREVIEW_ERROR':
      return Object.assign({}, state, {
        previewError: action.value
      });
  };

  return state;
}

const store = createStore( rootReducer );

export default store;
