<?php

namespace GS_Instagram\Backend;

class Enqueue {

    /**
     * @var string
     */
    protected $page_hook;

    /**
     * Constructor
     */
    public function __construct( $page_hook ) {
        $this->page_hook = $page_hook;

        $this->load_settings_page_scripts();

        $this->free_plugins_list_style();
    }

    /**
     * Load all scripts needed for settings page
     */
    private function load_settings_page_scripts() {
        if ( 'gs-plugins_page_gs-instagram-settings' != $this->page_hook ) {
            return;
        }

        // CSS
        wp_enqueue_style('gs-instagram-settings', GS_INSTAGRAM_ADMIN_ASSETS_URL . '/css/settings.css', [], GS_INSTAGRAM_VERSION, 'all' );

        // JS
        wp_enqueue_script( 'gs-instagram-settings', GS_INSTAGRAM_ADMIN_ASSETS_URL . '/js/settings.js', [ 'jquery' ], GS_INSTAGRAM_VERSION, 'true' );
        wp_localize_script( 'gs-instagram-settings', 'GS_Instagram', [
            'version'            => GS_INSTAGRAM_VERSION,
            'gsInstagramRootUrl' => GS_INSTAGRAM_ROOT_URL,
        ] );
    }

    /**
     * Load style on free plugins list
     */
    private function free_plugins_list_style() {
        if ( 'gs-plugins_page_gs-plugins-free' != $this->page_hook ) {
            return;
        }

        wp_enqueue_style( 'gs-plugins-free-insta', GS_INSTAGRAM_ADMIN_ASSETS_URL . '/css/gs-free-plugins.css', [], GS_INSTAGRAM_VERSION, 'all' );
    }

}
