import { createStore } from 'redux';

/**
 * Initial state
 */
var initialState = {
  theme: {},
  items: [],
  hasNextPage: false,
}

/**
 * Update theme
 */
export function updateTheme( value ) {
  return { type: 'INSTAGRAM_THEME', value: value }
}

/**
 * Update instagram items
 */
export function updateItems( value ) {
  return { type: 'INSTAGRAM_ITEMS', value: value }
}

/**
 * Update next cursor
 */
export function updateNextPageStatus( value ) {
  return { type: 'NEXT_PAGE_STATUS', value: value }
}

/**
 * Reducer
 */
export function rootReducer(state = initialState, action) {
  switch (action.type) {
    case 'INSTAGRAM_ITEMS':
      return Object.assign({}, state, {
        items: action.value
      });

    case 'INSTAGRAM_THEME':
      return Object.assign({}, state, {
        theme: action.value
      });

    case 'NEXT_PAGE_STATUS':
      return Object.assign({}, state, {
        hasNextPage: action.value
      });
  };

  return state;
}

var store = createStore( rootReducer );

export default store;
