import React from 'react';
import { connect } from 'react-redux';

class ThemePosts extends React.Component {

  constructor( props ) {
    super( props );

    this.themeItem = this.themeItem.bind(this);
  }

  render() {
    var themeStyle = this.props.theme.theme_style;

    return (
      <div className={ "gs-instagram-theme-container " + themeStyle }>
        <div className={"gs-instagram-theme-row " + themeStyle + "-row "}>
          {this.props.items.map( (item) => this.themeItem(item) )}
        </div>
      </div>
    );
  }

  themeItem( item ) {
    var { columns, link_target } = this.props.theme;

    return (
      <div
        className={"gsip-theme-columns gsip-columns-" + columns }
        key={item.id.toString()}
      >
        <a
          href={'https://www.instagram.com/p/' + item.shortcode}
          target={link_target}
        >
          <img src={item.thumbnail_src} />
        </a>
      </div>
    );
  }

}

function mapStateToProps( state ) {
  return {
    theme: state.theme,
    items: state.items,
  };
}

export default connect( mapStateToProps )( ThemePosts );
