<?php

namespace GS_Instagram\Frontend;

class Enqueue {

    /**
     * Constructor of Shortcode class
     */
    public function __construct() {
        $this->load_css();

        $this->load_js();
    }

    /**
     * Link CSS
     */
    private function load_css() {
        wp_register_style( 'gsip-public-style', GS_INSTAGRAM_PUBLIC_ASSETS_URL . '/css/gsip-public.css', [], GS_INSTAGRAM_VERSION, 'all' );
    }

    /**
     * Link js
     */
    private function load_js() {
        wp_enqueue_script( 'jquery' );

        wp_register_script( 'gsip-public-script', GS_INSTAGRAM_PUBLIC_ASSETS_URL . '/js/gsip-public.js', [ 'jquery' ], GS_INSTAGRAM_VERSION, true );

        $instagram_settings = get_option( 'gs_instagram_settings', [] );

        wp_localize_script( 'gsip-public-script', 'GS_Instagram', [
            'gsInstagramRootUrl' => GS_INSTAGRAM_ROOT_URL,
            'ajaxUrl'            => admin_url( 'admin-ajax.php' ),
            'show_load_more'     => isset( $instagram_settings['show_load_more_button'] ) ? boolval( $instagram_settings['show_load_more_button'] ) : true,
            'load_more_text'     => isset( $instagram_settings['load_more_button_text'] ) ? $instagram_settings['load_more_button_text'] : 'Load More',
        ] );
    }
}
